const int PIN_LED1 = 4;
const int PIN_LED2 = 5;
TaskHandle_t taskA, taskB;  // タスクのハンドルを保持する変数を用意する

void funcTaskA(void *) {    // taskA用の関数
    while (true) {      // 必ず無限ループにする
        digitalWrite(PIN_LED1, HIGH);
        delay(500);     // ③ 一定時間待機する
        digitalWrite(PIN_LED1, LOW);
        delay(500);     // ③ 一定時間待機する
    }
}

void funcTaskB(void *) { // taskB用の関数
    TickType_t prevTime = xTaskGetTickCount();
    while (true) {      // 必ず無限ループにする
        digitalWrite(PIN_LED2, HIGH);
        vTaskDelayUntil(&prevTime, 1000 / portTICK_PERIOD_MS);  // ④ 一定周期になるように待機する
        digitalWrite(PIN_LED2, LOW);
        vTaskDelayUntil(&prevTime, 1000 / portTICK_PERIOD_MS);  // ④ 一定周期になるように待機する
    }
}

void setup() {
    pinMode(PIN_LED1, OUTPUT);
    pinMode(PIN_LED2, OUTPUT);

    xTaskCreatePinnedToCore(funcTaskA, "taskA", 1024, NULL, 5, &taskA, 1);  // ① タスクを作成する
    xTaskCreatePinnedToCore(funcTaskB, "taskB", 1024, NULL, 5, &taskB, 1);  // ① タスクを作成する
}

void loop() {
    // 何もしない
}
