const int PIN_LED1 = 4;
const int PIN_LED2 = 5;

TaskHandle_t taskA, taskB;
QueueHandle_t queue;    // キューのハンドルを保持する変数を用意する

// キューで受け渡すデータの構造体を定義する
struct Message {
    uint8_t pin;
    uint8_t value;
};

void funcTaskA(void *) {    // taskA用の関数
    while (true) {
        Message messageToSend = {PIN_LED1, HIGH};   // 入れるデータを用意する
        xQueueSendToBack(queue, &messageToSend, 0); // ③キューにデータを入れる
        delay(500);
        messageToSend = {PIN_LED2, HIGH};
        xQueueSendToBack(queue, &messageToSend, 0); // ③キューにデータを入れる
        delay(500);
        messageToSend = {PIN_LED1, LOW};
        xQueueSendToBack(queue, &messageToSend, 0); // ③キューにデータを入れる
        delay(500);
        messageToSend = {PIN_LED2, LOW};
        xQueueSendToBack(queue, &messageToSend, 0); // ③キューにデータを入れる
        delay(500);
    }
}

void funcTaskB(void *) { // taskB用の関数
    Message receivedMessage;
    while (true) {
        if (xQueueReceive(queue, &receivedMessage, portMAX_DELAY)) {    // ④キューからデータを受け取る　portMAX_DELAYは最大時間待つという意味
            digitalWrite(receivedMessage.pin, receivedMessage.value);
        }
    }
}

void setup() {
    pinMode(PIN_LED1, OUTPUT);
    pinMode(PIN_LED2, OUTPUT);

    queue = xQueueCreate(10, sizeof(Message));   // ①キューを作成する

    xTaskCreatePinnedToCore(funcTaskA, "taskA", 1024, NULL, 5, &taskA, 1);
    xTaskCreatePinnedToCore(funcTaskB, "taskB", 1024, NULL, 10, &taskB, 1);
}

void loop() {
    // 何もしない
}
