const int PIN_LED1 = 4;
const int PIN_LED2 = 5;
TaskHandle_t taskA, taskB;
SemaphoreHandle_t semaphore;    // セマフォのハンドルを保持する変数を用意する

void funcTaskA(void *) {
    while (true) {
        xSemaphoreTake(semaphore, portMAX_DELAY); // ⑤セマフォを取得する
        digitalWrite(PIN_LED1, HIGH);
        delay(500);
        digitalWrite(PIN_LED1, LOW);
        xSemaphoreGive(semaphore);  // ⑥セマフォを開放する
        delay(500);
    }
}

void funcTaskB(void *) { // taskB用の関数
    while (true) {
        xSemaphoreTake(semaphore, portMAX_DELAY); // ⑤セマフォを取得する
        digitalWrite(PIN_LED2, HIGH);
        delay(750);
        digitalWrite(PIN_LED2, LOW);
        xSemaphoreGive(semaphore);  // ⑥セマフォを開放する
        delay(750);
    }
}

void setup() {
    pinMode(PIN_LED1, OUTPUT);
    pinMode(PIN_LED2, OUTPUT);

    semaphore = xSemaphoreCreateBinary();   // ①バイナリセマフォを作成する
    xSemaphoreGive(semaphore);  // ⑥セマフォを開放する

    xTaskCreatePinnedToCore(funcTaskA, "taskA", 1024, NULL, 5, &taskA, 1);
    xTaskCreatePinnedToCore(funcTaskB, "taskB", 1024, NULL, 5, &taskB, 1);
}

void loop() {
    // 何もしない
}
