const int PIN_LED1 = 4;
const int PIN_LED2 = 5;
const int PIN_SW = 0;
TimerHandle_t timerA, timerB;

void timerCallback(TimerHandle_t timer) {
    char id = (int32_t) pvTimerGetTimerID(timer);   // ②タイマのIDを取得する
    switch (id) {
        case 'A':
            digitalWrite(PIN_LED1, LOW);
            break;
        case 'B':
            digitalWrite(PIN_LED2, LOW);
            break;
    }
}

void setup() {
    pinMode(PIN_LED1, OUTPUT);
    pinMode(PIN_LED2, OUTPUT);
    pinMode(PIN_SW, INPUT_PULLUP);

    timerA = xTimerCreate("timerA", 200 / portTICK_PERIOD_MS, pdFALSE, (void *) 'A', timerCallback);    // ①タイマを作成する
    timerB = xTimerCreate("timerB", 2000 / portTICK_PERIOD_MS, pdFALSE, (void *) 'B', timerCallback);   // ①タイマを作成する
}

void loop() {
    digitalWrite(PIN_LED1, HIGH);
    xTimerStart(timerA, 0); // ⑤タイマを開始する 待ち時間0
    if (digitalRead(PIN_SW) == LOW) {
        digitalWrite(PIN_LED2, HIGH);
        xTimerReset(timerB, 0); // ⑤タイマをリセットする（停止時は開始する） 待ち時間0
    }
    delay(1000);
}
